#!/usr/bin/python
# -*- coding:utf8 -*-

"""
Codé par 20-100 le 21/04/12

Sert à connaître le solde d'un compte à une date t donnée.

Usage : solde_date.py idbde date
"""

import sys
import psycopg2
import psycopg2.extras

import base

def get_solde_date(idbde, date="now"):
    """Calcule le solde du compte ``idbde`` à la ``date`` donnée."""
    con, cur = base.getcursor()
    cur.execute(
        """
        SELECT COALESCE(sum(montant*quantite), 0)
        FROM transactions
        WHERE valide
          AND destinataire = %s
          AND date <= CAST(%s AS timestamp)
        """,
        (idbde, date))
    received = cur.fetchone()[0]
    cur.execute(
        """
        SELECT COALESCE(sum(montant*quantite), 0)
        FROM transactions
        WHERE valide
          AND emetteur = %s
          AND date <= CAST(%s AS timestamp)
        """,
        (idbde, date))
    given = cur.fetchone()[0]
    return received - given

if __name__ == "__main__":
    idbde = int(sys.argv[1])
    date = " ".join(sys.argv[2:])
    solde = get_solde_date(idbde, date)
    print solde/100.
